/*****************************************************************/
/*																 */
/*	 CASIO fx-9860G SDK Library 								 */
/*																 */
/*	 File name : [ProjectName].c								 */
/*																 */
/*	 Copyright (c) 2006 CASIO COMPUTER CO., LTD.				 */
/*																 */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "fxlib.h"


//------------------------------------------------------------------------------
int KeyCheckAC(void)		// [AC]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 1 ) && (kcode2 == 1 ) ) flag0=1; // [AC] is down
	}
	return flag0;
}

int KeyCheckEXE(void)		// [EXE]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 3 ) && (kcode2 == 2 ) ) flag0=1; // [EXE] is down
	}
	return flag0;
}

int KeyCheckPlusMinus(void) // (-)
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 4 ) && (kcode2 == 2 ) ) flag0=1; // [(-)] is down
	}
	return flag0;
}


//------------------------------------------------------------------------------
void plot_on_VRAM(x, y)
{
		Bdisp_SetPoint_VRAM(x, 63-y, 1);
}

void plot_on_DD(x, y)
{
		Bdisp_SetPoint_VRAM(x, 63-y, 1);
		Bdisp_PutDisp_DD();
}

//------------------------------------------------------------------------------

//============================================================================
// @\d̏
// http://akatuki-724.blogspot.jp/2016/10/hpgcc.html
// akatukil̃TCgɃAbvĂHPGCC̃vO
// CASIO fx-9860GIIւ̈ڐAłłB
//============================================================================
#define  M_PI	3.14159265358979323
#define  WIDTH	 128
#define  HEIGHT   64
//	̑傫Ea
#define  R		  32

//	rand() ̏ (ARMɂ͂Ȃ̂ŁAKvɂȂ)
//#ifndef	HPAPINE
//#define	RAND_MAX  4294967295
//#endif	/*	HPAPINE  */

/*	variables  */

/*	functions  */

//	xWAɕϊT[rX
double	radian(double radian)
{
	return	radian*2*M_PI/360;
}

//	]̈ꎟϊT[rX
//	̉]X邽߂Ɏgp
void rotate(double *x, double *y, double *z, double Th, double Ph)
{
   double  tx, ty;

	//	rotate for Ph
	tx =  (*x)*cos(Ph)+(*z)*sin(Ph);
	ty = -(*x)*sin(Ph)+(*z)*cos(Ph);
	*x = tx; *z = ty;

	//	rotate for Th
	tx =  (*x)*cos(Th)-(*y)*sin(Th);
	ty =  (*x)*sin(Th)+(*y)*cos(Th);
	*x = tx; *y = ty;

}


//	OtBNX\
//	̈ܓx~`
void  grobe(int  idx)
{
	double	x,	y,	z;
	double	xn, yn, zn;
	double	theta, phi, Th, Ph;
	double	dt, dp;

	//	ŠXEx (radian)ŗ^
	Th = radian(25);
	//	XS̉]Ex (radian)ŗ^
	Ph = radian(idx);

	//	dt͈ܓx~`oxticks
	dt = radian(10);
	//	dp͈ܓx~̈ܓxticks
	dp = radian(10);

	//
	for (phi = radian(-90); phi <= radian(90); phi += dp)
	  for (theta = 0; theta < radian(360); theta += dt) {

		x  = R * cos(theta)*cos(phi);
		y  = R * sin(theta)*cos(phi);
		z  = R * sin(phi);
		rotate(&x, &y, &z, Th, Ph);

		xn = R * cos(theta+dt)*cos(phi);
		yn = R * sin(theta+dt)*cos(phi);
		zn = R * sin(phi);
		rotate(&xn, &yn, &zn, Th, Ph);

		//	y-zʂ́u瑤v(x>=0)̏ꍇɁA`
		//	ȈՉA
		if (x >= 0)
			Bdisp_DrawLineVRAM(WIDTH/2+y,  HEIGHT/2-z, WIDTH/2+yn, HEIGHT/2-zn); 

	  }
}

void globe_main1(){
	int  idx = 0;

	//	_uobt@gp邽߁Aʃ[hw
	//	ʃ[hw肷鎖ŁA`̓obt@ɑ΂čs
	//	  hpg_set_mode_mono(1);
	Bdisp_AllClr_DDVRAM();

	//full speed ahead
	//	  sys_slowOff();
 
	//	L[͑҂܂ރ[v
	while(!KeyCheckAC()) { //  loop until ON pressed

		//	ʃNA
		Bdisp_AllClr_VRAM();
		//	OtBNX쐬
		grobe(idx);

		//	
		idx = (idx < 180) ? idx+10 : 0;

		//	OtBNX쐬obt@̉ʂ\
		//	hpg_flip(); //updates the screen with the new image (needed in double-buffered mode)
		Bdisp_PutDisp_DD();

//		  sys_waitRTCTicks(1);
	}
}




//============================================================================
//============================================================================
// vZʂ𔼕ɕύX
//============================================================================

//	]̈ꎟϊT[rX
//	̉]X邽߂Ɏgp
void rotate2(double *x, double *y, double *z, double Th, double Ph)
{
   double  tx, ty;

	//	rotate for Ph
	tx =  (*x)*cos(Ph)+(*z)*sin(Ph);
	ty = -(*x)*sin(Ph)+(*z)*cos(Ph);
	*x = tx; *z = ty;

	//	rotate for Th
	tx =  (*x)*cos(Th)-(*y)*sin(Th);
	ty =  (*x)*sin(Th)+(*y)*cos(Th);
	*x = tx; *y = ty;

}


//	OtBNX\
//	̈ܓx~`
void  grobe2(int  idx)
{
	double	x,	y,	z;
	double	xn, yn, zn;
	double	theta, phi, Th, Ph;
	double	dt, dp;

	//	ŠXEx (radian)ŗ^
	Th = radian(25);
	//	XS̉]Ex (radian)ŗ^
	Ph = radian(idx);

	//	dt͈ܓx~`oxticks
	dt = radian(10);
	//	dp͈ܓx~̈ܓxticks
	dp = radian(10);

	//
	for (phi = radian(-90); phi <= radian(90); phi += dp)
	  for (theta = 0; theta < radian(360); theta += dt) {

		x  = R * cos(theta)*cos(phi);
		y  = R * sin(theta)*cos(phi);
		z  = R * sin(phi);
		rotate(&x, &y, &z, Th, Ph);

		if (theta == 0) {
			yn = y ;
			zn = z ;
		}

		//	y-zʂ́u瑤v(x>=0)̏ꍇɁA`
		//	ȈՉA
		if (x >= 0)
			Bdisp_DrawLineVRAM(WIDTH/2+y,  HEIGHT/2-z, WIDTH/2+yn, HEIGHT/2-zn); 

		yn = y ;
		zn = z ;

	  }
}

void globe_main2(){
	int  idx = 0;

	//	_uobt@gp邽߁Aʃ[hw
	//	ʃ[hw肷鎖ŁA`̓obt@ɑ΂čs
	//	  hpg_set_mode_mono(1);
	Bdisp_AllClr_DDVRAM();

	//full speed ahead
	//	  sys_slowOff();
 
	//	L[͑҂܂ރ[v
	while(!KeyCheckAC()) { //  loop until ON pressed

		//	ʃNA
		Bdisp_AllClr_VRAM();
		//	OtBNX쐬
		grobe2(idx);

		//	
		idx = (idx < 180) ? idx+10 : 0;

		//	OtBNX쐬obt@̉ʂ\
		//	hpg_flip(); //updates the screen with the new image (needed in double-buffered mode)
		Bdisp_PutDisp_DD();

//		  sys_waitRTCTicks(1);
	}
}




//============================================================================
//============================================================================
// vZʂ𔼕ɕύX + Op֐vZʉ
//============================================================================

//	OtBNX\
//	̈ܓx~`
void  grobe3(int  idx)
{
	double	x,	y,	z;
	double	xn, yn, zn;
	double	theta, phi, Th, Ph;
	double	dt, dp;
	double	cosTh,sinTh,cosPh,sinPh;
	double	cosphi,tx;

	//	ŠXEx (radian)ŗ^
	Th = radian(25);
	//	XS̉]Ex (radian)ŗ^
	Ph = radian(idx);

	//	dt͈ܓx~`oxticks
	dt = radian(10);
	//	dp͈ܓx~̈ܓxticks
	dp = radian(10);

	cosTh = cos(Th);
	sinTh = sin(Th);
	cosPh = cos(Ph);
	sinPh = sin(Ph);

	//
	for (phi = radian(-90); phi <= radian(90); phi += dp)
	  for (theta = 0; theta < radian(360); theta += dt) {

		cosphi = cos(phi);

		x  = R * cos(theta)*cosphi;
		y  = R * sin(theta)*cosphi;
		z  = R * sin(phi);
		
		//	rotate for Ph
		tx =  (x)*cosPh+(z)*sinPh;
		z  = -(x)*sinPh+(z)*cosPh;
		x  = tx;
		
		//	rotate for Th
		tx =  (x)*cosTh-(y)*sinTh;
		y  =  (x)*sinTh+(y)*cosTh;
		x  = tx;

		if (theta == 0) {
			yn = y ;
			zn = z ;
		}

		//	y-zʂ́u瑤v(x>=0)̏ꍇɁA`
		//	ȈՉA
		if (x >= 0)
			Bdisp_DrawLineVRAM(WIDTH/2+y,  HEIGHT/2-z, WIDTH/2+yn, HEIGHT/2-zn); 

		yn = y ;
		zn = z ;

	  }
}

void globe_main3(){
	int  idx = 0;

	//	_uobt@gp邽߁Aʃ[hw
	//	ʃ[hw肷鎖ŁA`̓obt@ɑ΂čs
	//	  hpg_set_mode_mono(1);
	Bdisp_AllClr_DDVRAM();

	//full speed ahead
	//	  sys_slowOff();
 
	//	L[͑҂܂ރ[v
	while(!KeyCheckAC()) { //  loop until ON pressed

		//	ʃNA
		Bdisp_AllClr_VRAM();
		//	OtBNX쐬
		grobe3(idx);

		//	
		idx = (idx < 180) ? idx+10 : 0;

		//	OtBNX쐬obt@̉ʂ\
		//	hpg_flip(); //updates the screen with the new image (needed in double-buffered mode)
		Bdisp_PutDisp_DD();

//		  sys_waitRTCTicks(1);
	}
}


//============================================================================


//****************************************************************************
//	AddIn_main (Sample program main function)
//
//	param	:	isAppli   : 1 = This application is launched by MAIN MENU.
//						  : 0 = This application is launched by a strip in eACT application.
//
//				OptionNum : Strip number (0~3)
//						   (This parameter is only used when isAppli parameter is 0.)
//
//	retval	:	1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	unsigned int key;
	int cont=1;
	int mode=0; // mode=0: LCD transfer check, mode=1: key scan check


	while( cont ) {
		Bdisp_AllClr_DDVRAM();
		locate(1,1);Print((unsigned char*)"F1:Globe original");
		locate(1,2);Print((unsigned char*)"F2:Globe opt1");
		locate(1,3);Print((unsigned char*)"F3:Globe opt2");
		locate(1,7);Print((unsigned char*)"[AC]:break");
		
		GetKey(&key);
		switch (key) {
//			case KEY_CTRL_EXIT:
//				cont=0;
//				break;
				
			case KEY_CTRL_F1:
				globe_main1();
				break;
			case KEY_CTRL_F2:
				globe_main2();
				break;
			case KEY_CTRL_F3:
				globe_main3();
				break;
				
			default:
				break;
		}
	}
	return 1;
}



//****************************************************************************
//**************											  ****************
//**************				 Notice!					  ****************
//**************											  ****************
//**************  Please do not change the following source.  ****************
//**************											  ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//	InitializeSystem
//
//	param	:	isAppli   : 1 = Application / 0 = eActivity
//				OptionNum : Option Number (only eActivity)
//
//	retval	:	1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
	return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

